diff -Naur -X diff_ignore rsync-3.0.6_base/rsync.h rsync/rsync.h
--- rsync-3.0.6_base/rsync.h	2009-06-18 17:30:46.000000000 -0400
+++ rsync/rsync.h	2018-03-23 12:22:28.000000000 -0400
@@ -81,6 +81,7 @@
 #define FLAG_LENGTH64 (1<<9)	/* sender/receiver/generator */
 #define FLAG_SKIP_GROUP (1<<10)	/* receiver/generator */
 #define FLAG_TIME_FAILED (1<<11)/* generator */
+#define FLAG_XATTRS_SENT (1<<12)/* receiver */
 
 /* These flags are passed to functions but not stored. */
 
@@ -125,10 +126,10 @@
 #define RSYNC_PORT 873
 
 #define SPARSE_WRITE_SIZE (1024)
-#define WRITE_SIZE (32*1024)
-#define CHUNK_SIZE (32*1024)
-#define MAX_MAP_SIZE (256*1024)
-#define IO_BUFFER_SIZE (4092)
+//#define WRITE_SIZE (1*1024*1024) // No longer used
+#define CHUNK_SIZE (16*1024)
+#define MAX_MAP_SIZE (2*1024*1024)
+#define IO_BUFFER_SIZE (2*1024*1024)
 #define MAX_BLOCK_SIZE ((int32)1 << 17)
 
 /* For compatibility with older rsyncs */
@@ -158,6 +159,7 @@
 #define ATTRS_SKIP_MTIME	(1<<1)
 #define ATTRS_DELAY_IMMUTABLE	(1<<2)
 #define ATTRS_SKIP_CRTIME	(1<<3)
+#define ATTRS_STRIP_RESTRICTED	(1<<4)
 
 #define FULL_FLUSH	1
 #define NORMAL_FLUSH	0
@@ -194,6 +196,11 @@
 #define ITEM_MISSING_DATA (1<<16)	   /* used by log_formatted() */
 #define ITEM_DELETED (1<<17)		   /* used by log_formatted() */
 #define ITEM_MATCHED (1<<18)		   /* used by itemize() */
+#define ITEM_EXCLUDED (1<<19)		   /* used by log_formatted() */
+#define ITEM_PROTECTED (1<<20)		   /* used by log_formatted() */
+#define ITEM_ARCHIVED (1<<21)		   /* used by log_formatted() */
+#define ITEM_HAD_ERRORS_SOURCE (1<<24) /* used by log_formatted() */
+#define ITEM_HAD_ERRORS_DEST (1<<25)   /* used by log_formatted() */
 
 #define SIGNIFICANT_ITEM_FLAGS (~(\
 	ITEM_BASIS_TYPE_FOLLOWS | ITEM_XNAME_FOLLOWS | ITEM_LOCAL_CHANGE))
@@ -237,6 +244,8 @@
 	MSG_SUCCESS=100,/* successfully updated indicated flist index */
 	MSG_DELETED=101,/* successfully deleted a file on receiving side */
 	MSG_NO_SEND=102,/* sender failed to open a file we wanted */
+	MSG_FILTERED=103, /* file was hidden or protected on the sender or receiving side*/
+	MSG_ARCHIVED=104, /* file was hidden or protected on the sender or receiving side*/
 	MSG_DONE=86	/* current phase is done */
 };
 
@@ -485,10 +494,39 @@
 #define SYS_IMMUTABLE (SF_IMMUTABLE|SF_NOUNLINK|SF_APPEND)
 #define ALL_IMMUTABLE (USR_IMMUTABLE|SYS_IMMUTABLE)
 #define ST_FLAGS(st) (st.st_flags)
+#define ALL_FFLAGS (UF_NODUMP | USR_IMMUTABLE | UF_OPAQUE | UF_COMPRESSED | UF_HIDDEN | UF_TRACKED | SF_ARCHIVED | SYS_IMMUTABLE | SF_RESTRICTED | SF_NOUNLINK)
 #else
 #define ST_FLAGS(st) NO_FFLAGS
 #endif
 
+#include <sys/attr.h>
+#ifndef XATTR_SHOWCOMPRESSION
+#define XATTR_SHOWCOMPRESSION 0x0020
+#endif
+#ifndef UF_COMPRESSED
+#define UF_COMPRESSED 0x00000020
+#endif
+#ifndef UF_TRACKED
+#define UF_TRACKED		0x00000040	/* file renames and deletes are tracked */
+#endif
+#ifndef XATTR_DECMPFS_NAME
+#define	XATTR_DECMPFS_NAME	  "com.apple.decmpfs"
+#endif
+#ifndef XATTR_RESOURCEFORK_NAME
+#define	XATTR_RESOURCEFORK_NAME	  "com.apple.ResourceFork"
+#endif
+#ifndef KAUTH_FILESEC_XATTR
+#define	KAUTH_FILESEC_XATTR	  "com.apple.system.Security"
+#endif
+#ifndef VOL_CAP_FMT_DECMPFS_COMPRESSION
+#define VOL_CAP_FMT_DECMPFS_COMPRESSION	0x00010000
+#endif
+#define SETXATTR_CHUNKSIZE (1024*1024*64)
+
+#if defined SUPPORT_XATTRS && defined SUPPORT_FILEFLAGS
+#define SUPPORT_HFS_COMPRESSION 1
+#endif
+
 /* Find a variable that is either exactly 32-bits or longer.
  * If some code depends on 32-bit truncation, it will need to
  * take special action in a "#if SIZEOF_INT32 > 4" section. */
@@ -626,7 +664,7 @@
 #endif
 
 #ifndef NAME_MAX
-#define NAME_MAX 255
+#define NAME_MAX 238
 #endif
 
 #ifndef INADDR_NONE
@@ -726,6 +764,8 @@
 /* The sum is only present on regular files. */
 #define F_SUM(f) ((char*)OPT_EXTRA(f, LEN64_BUMP(f) + HLINK_BUMP(f) \
 				    + SUM_EXTRA_CNT - 1))
+#define FUNKY_SUM(f) ((char*)OPT_EXTRA(f, LEN64_BUMP(f) + HLINK_BUMP(f) + 1 \
++ SUM_EXTRA_CNT - 1))
 
 /* Some utility defines: */
 #define F_IS_ACTIVE(f) (f)->basename[0]
@@ -853,7 +893,9 @@
 
 struct stats {
 	int64 total_size;
+	int64 total_unchanged_size;
 	int64 total_transferred_size;
+	int64 xattr_transfer_size;
 	int64 total_written;
 	int64 total_read;
 	int64 literal_data;
@@ -861,8 +903,19 @@
 	int64 flist_buildtime;
 	int64 flist_xfertime;
 	int64 flist_size;
+	int64 perf;
+	int64 largest_file;
 	int num_files;
+	int num_xattrs;
 	int num_transferred_files;
+	int total_unchanged_count;
+	// BOMBICH
+	int num_dirs;
+	int num_reg_files;
+	int num_symlinks;
+	int num_devices;
+	int num_special;
+	int hard_links_not_copied;
 };
 
 struct chmod_mode_struct;
@@ -948,6 +1001,10 @@
 #define ACL_READY(sx) ((sx).acc_acl != NULL)
 #define XATTR_READY(sx) ((sx).xattr != NULL)
 
+// For statfs():
+#include <sys/param.h>
+#include <sys/mount.h>
+
 #include "proto.h"
 
 #ifndef SUPPORT_XATTRS
@@ -1148,7 +1205,7 @@
 #define	WIFEXITED(stat)		((int)((stat)&0xFF) == 0)
 #endif
 
-#define exit_cleanup(code) _exit_cleanup(code, __FILE__, __LINE__)
+#define exit_cleanup(code) _exit_cleanup(code, ((strrchr(__FILE__, '/') ?: __FILE__ - 1) + 1), __LINE__)
 
 #ifdef HAVE_GETEUID
 #define MY_UID() geteuid()
diff -Naur -X diff_ignore rsync-3.0.6_base/sender.c rsync/sender.c
--- rsync-3.0.6_base/sender.c	2009-04-12 15:48:59.000000000 -0400
+++ rsync/sender.c	2018-10-13 16:17:50.000000000 -0400
@@ -20,10 +20,12 @@
  */
 
 #include "rsync.h"
+#include <fcntl.h>
 
 extern int verbose;
 extern int do_xfers;
 extern int am_server;
+extern int rcvr_is_non_local_server;
 extern int am_daemon;
 extern int inc_recurse;
 extern int log_before_transfer;
@@ -34,6 +36,7 @@
 extern int io_error;
 extern int allowed_lull;
 extern int preserve_xattrs;
+extern int preserve_hfs_compression;
 extern int protocol_version;
 extern int remove_source_files;
 extern int updating_basis_file;
@@ -45,6 +48,17 @@
 extern struct stats stats;
 extern struct file_list *cur_flist, *first_flist, *dir_flist;
 
+// BOMBICH
+#define FORCE_SENDER_ERROR 0
+#ifdef PARSEABLE_OUTPUT
+struct timeval last_update;
+static unsigned long msdiff(struct timeval *t1, struct timeval *t2)
+{
+	return (t2->tv_sec - t1->tv_sec) * 1000L
+		+ (t2->tv_usec - t1->tv_usec) / 1000;
+}
+#endif
+
 /**
  * @file
  *
@@ -136,7 +150,7 @@
 		if (verbose > 1)
 			rprintf(FINFO, "sender removed %s\n", fname);
 	} else
-		rsyserr(FERROR, errno, "sender failed to remove %s", fname);
+		rsyserr(FERROR, errno, "successful_send: sender failed to remove %s", full_fname(fname));
 }
 
 static void write_ndx_and_attrs(int f_out, int ndx, int iflags,
@@ -175,8 +189,10 @@
 	int f_xfer = write_batch < 0 ? batch_fd : f_out;
 	int ndx, j;
 
-	if (verbose > 2)
+	if (verbose > 2) {
 		rprintf(FINFO, "send_files starting\n");
+		fprintf(stderr, "DEBUG: [send_files: %s] rcvr_is_non_local_server: %d\n", who_am_i(), rcvr_is_non_local_server);
+	}
 
 	while (1) {
 		if (inc_recurse)
@@ -260,11 +276,9 @@
 
 		if (!am_server && do_progress)
 			set_current_file_index(file, ndx);
-		stats.num_transferred_files++;
-		stats.total_transferred_size += F_LENGTH(file);
 
 		if (!do_xfers) { /* log the transfer */
-			log_item(FCLIENT, file, &stats, iflags, NULL);
+			log_item(FLOG, file, &stats, iflags, NULL);
 			write_ndx_and_attrs(f_out, ndx, iflags, fname, file,
 					    fnamecmp_type, xname, xlen);
 			continue;
@@ -279,6 +293,12 @@
 		}
 
 		fd = do_open(fname, O_RDONLY, 0);
+#if FORCE_SENDER_ERROR
+		if (random() % 10 == 0) {
+			exit(1);
+			return;
+		}
+#endif
 		if (fd == -1) {
 			if (errno == ENOENT) {
 				enum logcode c = am_daemon
@@ -287,11 +307,15 @@
 				io_error |= IOERR_VANISHED;
 				rprintf(c, "file has vanished: %s\n",
 					full_fname(fname));
+			} else if (errno == ENOTSUP && F_LENGTH(file) == 1) {
+				rprintf(FWARNING, "Dropping placeholder file: %s\n", full_fname(fname));
 			} else {
 				io_error |= IOERR_GENERAL;
+				iflags |= ITEM_HAD_ERRORS_SOURCE;
 				rsyserr(FERROR_XFER, errno,
-					"send_files failed to open %s",
+					"send_files: failed to open %s",
 					full_fname(fname));
+				log_item(FLOG, file, &stats, iflags, NULL);
 			}
 			free_sums(s);
 			if (protocol_version >= 30)
@@ -302,13 +326,51 @@
 		/* map the local file */
 		if (do_fstat(fd, &st) != 0) {
 			io_error |= IOERR_GENERAL;
-			rsyserr(FERROR_XFER, errno, "fstat failed");
+			rsyserr(FERROR_XFER, errno, "send_files: fstat failed on %s", full_fname(fname));
 			free_sums(s);
 			close(fd);
 			exit_cleanup(RERR_PROTOCOL);
 		}
 
+// BOMBICH
+// Update the user on total transfer size and the name of the file we're currently copying. 
+// To limit CPU usage, do this 5 times per second
+// We need to do this before stats.total_transferred_size is updated because match_sums() will add the current offset to this amount
+#ifdef PARSEABLE_OUTPUT
+		if (rcvr_is_non_local_server) {
+			struct timeval now;
+			gettimeofday(&now, NULL);
+			unsigned long time_diff = msdiff(&last_update, &now);
+			if (time_diff > 200) {
+				last_update = now;
+				rprintf(FINFO, "S;;;STATS;;;TTS;;;%lld;;;FC;;;%d;;;CF;;;%s\n", stats.total_transferred_size, stats.num_transferred_files, fname);
+			}
+		}
+#endif
+
+		off_t saved_file_length = st.st_size;
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (st.st_flags & UF_COMPRESSED) {
+			if (preserve_hfs_compression > 0) {
+				// We're sending the compression xattr, not the decompressed data fork. Setting rsync's idea of the 
+				// file size to 0 effectively prevents the transfer of the data fork
+				if (verbose > 1)
+					fprintf(stderr, "send_files(%s): Compress flag is set, setting file size to 0 (%s)\n", who_am_i(), full_fname(fname));
+				st.st_size = 0;
+				file->len32 = 0;
+			} else {
+				if (verbose)
+					fprintf(stderr, "DEBUG: send_files(%s): Stripping UF_COMPRESSED file flag (%s)\n", who_am_i(), full_fname(fname));
+				// If the sender's filesystem supports compression, then we'll be able to send the decompressed data fork
+				// and the decmpfs xattr will be hidden (not sent). As such, we need to strip the compression flag.
+				st.st_flags &= ~UF_COMPRESSED;
+			}
+		}
+#endif
+	
 		if (st.st_size) {
+//			struct radvisory rad = {0, st.st_size};
+//			fcntl(fd, F_RDADVISE, rad);
 			int32 read_size = MAX(s->blength * 3, MAX_MAP_SIZE);
 			mbuf = map_file(fd, st.st_size, read_size, s->blength);
 		} else
@@ -328,7 +390,7 @@
 
 		if (log_before_transfer)
 			log_item(FCLIENT, file, &initial_stats, iflags, NULL);
-		else if (!am_server && verbose && do_progress)
+		else if (!am_server && verbose > 1 && do_progress)
 			rprintf(FCLIENT, "%s\n", fname);
 
 		set_compression(fname);
@@ -337,17 +399,27 @@
 		if (do_progress)
 			end_progress(st.st_size);
 
-		log_item(log_code, file, &initial_stats, iflags, NULL);
-
+		// Update the stats after match_sums() so the current file isn't included twice in the output
+		stats.num_transferred_files++;
+		// Non-Finder math method: Use st.st_size instead of saved_file_length
+		stats.total_transferred_size += saved_file_length;
+		//fprintf(stderr, "DEBUG: [%s] SNDFIL: stats.total_transferred_size |%s|+%lld\n", who_am_i(), full_fname(fname), st.st_size);
+		
 		if (mbuf) {
 			j = unmap_file(mbuf);
 			if (j) {
 				io_error |= IOERR_GENERAL;
 				rsyserr(FERROR_XFER, j,
-					"read errors mapping %s",
+					"send_files: read errors mapping %s",
 					full_fname(fname));
+				iflags |= ITEM_HAD_ERRORS_SOURCE;
+				stats.num_transferred_files--;
+				stats.total_transferred_size -= F_LENGTH(file);
 			}
 		}
+
+		log_item(log_code, file, &initial_stats, iflags, NULL);
+
 		close(fd);
 
 		free_sums(s);
@@ -366,5 +438,12 @@
 
 	match_report();
 
+// BOMBICH
+#ifdef PARSEABLE_OUTPUT
+	// Print the grand total
+	rprintf(FINFO, "S;;;SUM_STATS;;;TS;;;%lld;;;TTS;;;%lld;;;FC;;;%d;;;DIRS;;;%d;;;REG;;;%d;;;SYM;;;%d;;;DEV;;;%d;;;SPEC;;;%d;;;HLNK;;;%d;;;XATTR;;;%d;;;XS;;;%lld;;;LF;;;%lld\n", stats.total_size, stats.total_transferred_size, stats.num_transferred_files, stats.num_dirs, stats.num_reg_files, stats.num_symlinks, stats.num_devices, stats.num_special, stats.hard_links_not_copied, stats.num_xattrs, stats.xattr_transfer_size, stats.largest_file);
+//	rprintf(FINFO, "Performance (sender): %lu\n", (unsigned long)stats.perf);
+#endif
+
 	write_ndx(f_out, NDX_DONE);
 }
diff -Naur -X diff_ignore rsync-3.0.6_base/support/cull_options rsync/support/cull_options
--- rsync-3.0.6_base/support/cull_options	1969-12-31 19:00:00.000000000 -0500
+++ rsync/support/cull_options	2014-12-06 21:12:18.000000000 -0500
@@ -0,0 +1,64 @@
+#!/usr/bin/perl
+# This script outputs some perl code that parses all possible options
+# that the code in options.c might send to the server.  This perl code
+# is included in the rrsync script.
+use strict;
+
+our(%short_no_arg, %short_with_num, %long_opt);
+our $last_long_opt;
+
+open(IN, '../options.c') or die "Unable to open ../options.c: $!\n";
+
+while (<IN>) {
+    if (/\Qargstr[x++]\E = '(.)'/) {
+	$short_no_arg{$1} = 1;
+	undef $last_long_opt;
+    } elsif (/\Qasprintf(\E[^,]+, "-([a-zA-Z0-9])\%l?[ud]"/) {
+	$short_with_num{$1} = 1;
+	undef $last_long_opt;
+    } elsif (/\Qargs[ac++]\E = "--([^"=]+)"/) {
+	$last_long_opt = $1;
+	$long_opt{$1} = 0;
+    } elsif (defined($last_long_opt)
+	&& /\Qargs[ac++]\E = ([^["\s]+);/ && $1 ne 'dest_option') {
+	$long_opt{$last_long_opt} = 2;
+	undef $last_long_opt;
+    } elsif (/dest_option = "--([^"]+)"/) {
+	$long_opt{$1} = 2;
+	undef $last_long_opt;
+    } elsif (/\Qasprintf(\E[^,]+, "--([^"=]+)=/ || /\Qargs[ac++]\E = "--([^"=]+)=/) {
+	$long_opt{$1} = 1;
+	undef $last_long_opt;
+    }
+}
+close IN;
+
+my $short_no_arg = join('', sort keys %short_no_arg);
+my $short_with_num = join('', sort keys %short_with_num);
+
+print <<EOT;
+
+# These options are the only options that rsync might send to the server,
+# and only in the option format that the stock rsync produces.
+
+# To disable a short-named option, add its letter to this string:
+our \$short_disabled = 's';
+
+our \$short_no_arg = '$short_no_arg'; # DO NOT REMOVE ANY
+our \$short_with_num = '$short_with_num'; # DO NOT REMOVE ANY
+
+# To disable a long-named option, change its value to a -1.  The values mean:
+# 0 = the option has no arg; 1 = the arg doesn't need any checking; 2 = only
+# check the arg when receiving; and 3 = always check the arg.
+our \%long_opt = (
+EOT
+
+foreach my $opt (sort keys %long_opt) {
+    my $val = $long_opt{$opt};
+    $val = 1 if $opt =~ /^(max-|min-)/;
+    $val = 3 if $opt eq 'files-from';
+    $val = '$ro ? -1 : ' . $val if $opt =~ /^remove-/;
+    print "  '$opt' => $val,\n";
+}
+
+print ");\n\n";
diff -Naur -X diff_ignore rsync-3.0.6_base/support/extern-squish rsync/support/extern-squish
--- rsync-3.0.6_base/support/extern-squish	1969-12-31 19:00:00.000000000 -0500
+++ rsync/support/extern-squish	2014-12-06 21:12:18.000000000 -0500
@@ -0,0 +1,18 @@
+#!/usr/bin/perl
+# This script finds extraneous "extern" variables in the *.c files.
+# Run it from inside the main rsync directory.
+
+use strict;
+
+my @files = glob('*.c');
+
+foreach my $fn (@files) {
+    open(IN, '<', $fn) or die;
+    undef $/; $_ = <IN>; $/ = "\n";
+    close IN;
+    my @externs = /^extern .*?([^[\s(*;&.]+)(?:\[.*?\])?;/mg;
+    foreach my $find (@externs) {
+	my @matches = /(?<!\sstruct )\b(\Q$find\E)\b/g;
+	print $fn, ': ', $find, "\n" if @matches == 1;
+    }
+}
diff -Naur -X diff_ignore rsync-3.0.6_base/support/patch-update rsync/support/patch-update
--- rsync-3.0.6_base/support/patch-update	1969-12-31 19:00:00.000000000 -0500
+++ rsync/support/patch-update	2014-12-06 21:12:18.000000000 -0500
@@ -0,0 +1,157 @@
+#!/usr/bin/perl -w
+# This script is used to turn one or more of the "patch/*" branches
+# into one or more diffs in the "patches" directory.  Pass the option
+# --gen if you want generated files in the diffs.  Pass the name of
+# one or more diffs if you want to just update a subset of all the
+# diffs.
+
+use strict;
+
+my $patches_dir = 'patches';
+my $incl_generated_files;
+
+if (@ARGV && $ARGV[0] =~ /^--gen(?:=(\S+))?$/) {
+    $patches_dir = $1 if defined $1;
+    $incl_generated_files = 1;
+    shift;
+}
+
+die "No '$patches_dir' directory was found.\n" unless -d $patches_dir;
+die "No '.git' directory present in the current dir.\n" unless -d '.git';
+
+my @extra_files;
+open(IN, '<', 'Makefile.in') or die "Couldn't open Makefile.in: $!\n";
+while (<IN>) {
+    if (s/^GENFILES=//) {
+	while (s/\\$//) {
+	    $_ .= <IN>;
+	}
+	@extra_files = split(' ', $_);
+	last;
+    }
+}
+close IN;
+
+system "git checkout master" and exit 1;
+if ($incl_generated_files) {
+    die "'a' must not exist in the current directory.\n" if -e 'a';
+    die "'b' must not exist in the current directory.\n" if -e 'b';
+    system "./config.status Makefile && make gen && rsync -a @extra_files a/" and exit 1;
+}
+my $last_touch = time;
+
+my(@patches, %local_patch);
+if (@ARGV) {
+    foreach (@ARGV) {
+	s{^(patches|patch|origin/patch)/} {};
+	s{\.diff$} {};
+	push(@patches, $_);
+    }
+    open(PIPE, '-|', 'git', 'branch', '-l') or die $!;
+} else {
+    open(PIPE, '-|', 'git', 'branch', '-a') or die $!;
+}
+while (<PIPE>) {
+    if (m# origin/patch/(.*)#) {
+	push(@patches, $1);
+    } elsif (m# patch/(.*)#) {
+	$local_patch{$1} = 1;
+    }
+}
+close PIPE;
+
+my(%parent, %description);
+foreach my $patch (@patches) {
+    my $branch = ($local_patch{$patch} ? '' : 'origin/') . "patch/$patch";
+    my $desc = '';
+    open(PIPE, '-|', 'git', 'diff', '-U1000', "master...$branch", '--', "PATCH.$patch") or die $!;
+    while (<PIPE>) {
+	last if /^@@ /;
+    }
+    while (<PIPE>) {
+	next unless s/^[ +]//;
+	if (m#patch -p1 <patches/(\S+)\.diff# && $1 ne $patch) {
+	    $parent{$patch} = $1;
+	}
+	$desc .= $_;
+    }
+    $description{$patch} = $desc;
+}
+
+my %completed;
+foreach my $patch (@patches) {
+    next if $completed{$patch}++;
+    update_patch($patch);
+}
+
+if ($incl_generated_files) {
+    system "rm -rf a b";
+}
+
+sleep 1 if $last_touch == time;
+system "git checkout master";
+
+exit;
+
+
+sub update_patch
+{
+    my($patch) = @_;
+
+    my $parent = $parent{$patch};
+    if (defined $parent) {
+	unless ($completed{$parent}++) {
+	    update_patch($parent);
+	}
+	$parent = "patch/$parent";
+    } else {
+	$parent = 'master';
+    }
+
+    print "======== $patch ========\n";
+
+    sleep 1 if $incl_generated_files && $last_touch == time;
+    if ($local_patch{$patch}) {
+	system "git checkout patch/$patch" and exit 1;
+    } else {
+	system "git checkout --track -b patch/$patch origin/patch/$patch" and exit 1;
+    }
+
+    open(OUT, '>', "$patches_dir/$patch.diff") or die $!;
+    print OUT $description{$patch}, "\n";
+
+    if (system("git rebase -m $parent") != 0) {
+	print qq|"git rebase -m $parent" incomplete -- please fix.\n|;
+	$ENV{PS1} = "[$parent] patch/$patch: ";
+	system $ENV{SHELL} and exit 1;
+    }
+
+    if ($incl_generated_files) {
+	system "./config.status Makefile && make gen && rsync -a @extra_files b/" and exit 1;
+    }
+    $last_touch = time;
+
+    open(PIPE, '-|', 'git', 'diff', $parent) or die $!;
+    DIFF: while (<PIPE>) {
+	while (m{^diff --git a/PATCH}) {
+	    while (<PIPE>) {
+		last if m{^diff --git a/};
+	    }
+	    last DIFF if !defined $_;
+	}
+	next if /^index /;
+	print OUT $_;
+    }
+    close PIPE;
+
+    if ($incl_generated_files) {
+	open(PIPE, '-|', 'diff', '-up', 'a', 'b') or die $!;
+	while (<PIPE>) {
+	    s/^((?:---|\+\+\+) [^\t]+)\t.*/$1/;
+	    print OUT $_;
+	}
+	close PIPE;
+    }
+
+    close OUT;
+}
